#ifndef cPLOTHEADER
#define cPLOTHEADER

#include <GL/glut.h>
#include <GL/gl.h>
#include "vector.h"
#include "cPlotData.h"
#include "cWindow.h"
#include <vector>

using namespace std;

//enum nRender {nPOINT = 1, nWIREFRAME = 2, nSURFACE = 3};

class cPlot
{
public:
	cPlot();
	
	//Input
	void AddData(cDataSet* DS){plotIndex.max = data.size(); data.push_back(DS);}; 

	//Rendering
	void Render();
	void RenderGraph();
	void RenderAxis();
	void RenderBox();
	void RenderSide();
	void RenderTitle();
	//void RenderScale();

	//Toggle properties
	void ToggleBox()		{bBox		= !bBox;};
	void ToggleAxis()		{bAxis		= !bAxis;};
	void ToggleArrow()		{bArrow		= !bArrow;};
	void ToggleGraph()		{bGraph		= !bGraph;};
	void ToggleScale()		{bScale		= !bScale;};
	
	void TogglePoint()		{bPoint		= !bPoint;};
	void ToggleWireframe()	{bWireframe = !bWireframe;};
	void ToggleSurface()	{bSurface	= !bSurface;};

	//Get
	cDataSet* GetData(int i){return data[i];};
	
	GLdouble* GetModel(void){return matModel;};
	GLdouble* GetProj(void){return matProjection;};
	
private:

	//data
	vector<cDataSet*> data;
	//int index;

	//Render helper
	//nRender typeRender;
	//bool bZooming;

	//model view matrix
	GLdouble matModel[16];
	GLdouble matProjection[16];
	bool bPoint;
	bool bWireframe;
	bool bSurface;

	bool bBox;
	bool bAxis;
	bool bArrow;
	bool bGraph;
	bool bScale;


};

#endif

