#ifndef PLOTDATAHEADER
#define PLOTDATAHEADER

#include <vector>
#include <string>
#include "vector.h"
using namespace std;

typedef double cFloat;

//Generic Matrix Class
template <class C>
struct cMatrix : public vector< vector<C> >
{
	void Resize(long r, long c, const C& init)
	{
		this->resize(r);
		for(long i=0; i<r; i++)
			(*this)[i].resize(c, init);
	};
};

class cDataSet
{
public:

	cDataSet(	cFloat (*func)(cFloat, cFloat),
				cColor (*funcColor)(cFloat),
				string cap = "");

	cFloat GetZ(cFloat x, cFloat y);
	cColor GetColor(cFloat z);
	string GetCaption(){return caption;};

private:

	//function
	cFloat (*f)(cFloat, cFloat);
	cColor (*fColor)(cFloat);
	string caption;
};

#endif