#ifndef WINDOWHEADER
#define WINDOWHEADER

//#include "cPlot.h"
#include "cInfo.h"
#include "vector.h"
#include <vector>

using namespace std;

//tell my code that this is compiled in windows
//#undef _WIN32
//#define _WIN32 //already handle and def in glut

//general const
//#define X 0	//conflict with windows.h
//#define Y 1
//#define Z 2

//color
#define cAXISR 255
#define cAXISG 255
#define cAXISB 255

//window
const int GAP = 30;
extern GLuint winMain;
extern GLuint winPlot;
extern GLuint winConfig;
extern GLuint winWorld;

const int gapLEFT = 15;
const int gapSTRING = 75;
const int gapLS = gapLEFT + gapSTRING;
const int gapNUM = 55;
const int gapTOP = 35;

void RedisplayAll(void);

//main window
const int mWIDTH = 850;
const int mHEIGHT = 600;

//plot window
const int pWIDTH = mHEIGHT;
const int pHEIGHT = mHEIGHT;
const int pLEFT = GAP;
const int pTOP = GAP;

class cPlot;
extern cPlot plot;
extern cell plotIndex;

//world window
const int wWIDTH = mWIDTH - pWIDTH;
const int wHEIGHT = wWIDTH;
const int wLEFT = GAP + pWIDTH + GAP;
const int wTOP = GAP;

//config window
const int cWIDTH = mWIDTH - pWIDTH;
const int cHEIGHT = mHEIGHT - wHEIGHT - GAP;	//cHEIGHT + GAP + wHEIGHT = mHEIGHT
const int cLEFT = GAP + pWIDTH + GAP;
const int cTOP = GAP + wHEIGHT + GAP;


extern int selection;
extern int old_y;
extern int old_x;

enum nMode {nView = 1,
			nAxis = 5,
			nZoom = 9,
			nColor = 13,
			nCamera = 100,
			nFont = 110,
			nCaption = 120,
			nSide = 130};
extern nMode mode;

//nView
extern cell scale[3];
extern cell rotate[3];
extern cell lookat[9];
extern cell perspective[4];

//nAxis
extern cell max[3];
extern cell min[3];
extern cell inc[3];
extern cell loc[3];
extern cell tick[3];
extern cell tinc[3];

//nZoom
extern cell zoom;
extern cell center[3];

//nColor
extern cell zmin;
extern cell zmax;
extern cButton addcolor;
cColor fcolor(GLdouble z);
	//cells to store z value and color
typedef pair<double, cColor> cColorSet;
extern vector<cColorSet> cs;

typedef vector<cell> cellVec;
extern vector<cellVec> zcCell;

extern vector<cButton> zcDel;

//nCamera

extern cell clattitude;
extern cell clongitude;
extern cell cradius;

//nFont
extern cButton f3D;
extern cButton fFill;
extern cButton fX;
extern cButton fY;
extern cButton fZ;
extern cell fXColor[3];
extern cell fYColor[3];
extern cell fZColor[3];
extern cell fSize[3];

//nCaption
extern cTextBox cTitle;
extern cTextBox cAxis[3];
extern cell cCorner;

//nSide
const int sFRONT = 0;
const int sBACK = 1;
const int sLEFT = 2;
const int sRIGHT = 3;
const int sTOP = 4;
const int sBOT = 5;

extern cButton sOn[6];
extern cButton sFill[6];
extern cButton sGrid[6];


//misc
const TOLERANCE = 0.0001; //tolerance for float
const MAXSTEP = 100;	//limit step for speed
const INF = 1000000.0;

#endif